/*
    This file is part of the oolaboola digital dj program

    Copyright (C) 1999  Eric S. Tiedemann

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <cstdlib>
#include <exception>
#include <cstddef>
  extern "C" {
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
	     }
#include <string>

#include "sexpr.h"

using namespace std;

#include <cmath>

#ifdef __linux__
extern "C" void usleep(unsigned long);
#endif

int
main1(int argc, char **argv)
{
  while (true)
    {
      sexpr s;
      
      cin >> s;
      
      if (s.eof_objectp())
	return 0;
      
      if (s.pairp())
	{
	  sexpr a(s.car());
	  sexpr l(s.cdr());
	  
	  if (sexpr::eq(a, sexpr::symbol("delta")))
	    {
	      if (l.pairp())
		{
		  sexpr a(l.car());
		  sexpr l(l.cdr());
		  
		  if (l.pairp() && a.floatp())
		    {
		      sexpr b(l.car());
		      double delay = double(a);
		      
		      // wait delay secs
		      usleep((unsigned long) floor(delay * 1000000));
		      
		      cout << b << "\n";
		      cout.flush();
		    }
		}
	    }
	}
    }
}

int
main(int argc, char **argv)
{
  try
    {
      return main1(argc, argv);
    }
  catch (exception &e)
    {
      cerr << "Unhandled exception: " << e.what() << "\n";
      return 1;
    }
  catch (...)
    {
      cerr << "Unknown unhandled exception!\n";
      return 1;
    }
      
  return 0;
}
